Index: t3lib/class.t3lib_tcemain.php
===================================================================
--- t3lib/class.t3lib_tcemain.php	(revision 9580)
+++ t3lib/class.t3lib_tcemain.php	(revision )
@@ -2594,17 +2588,17 @@
 
 				// Check if the table may be modified!
 			$modifyAccessList = $this->checkModifyAccessList($table);
-			if (!$modifyAccessList)	{
+			if (!$modifyAccessList) {
 				$id = 0;
-				$this->log($table,$id,2,0,1,"Attempt to modify table '%s' without permission",1,array($table));
+				$this->log($table, $id, 2, 0, 1, "Attempt to modify table '%s' without permission", 1, array($table));
-			}	// FIXME: $id not set here (Comment added by Sebastian Kurfürst)
+			} // FIXME: $id not set here (Comment added by Sebastian Kurfürst)
 
 				// Check basic permissions and circumstances:
-			if (isset($TCA[$table]) && !$this->tableReadOnly($table) && is_array($this->cmdmap[$table]) && $modifyAccessList)	{
+			if (isset($TCA[$table]) && !$this->tableReadOnly($table) && is_array($this->cmdmap[$table]) && $modifyAccessList) {
 
 					// Traverse the command map:
-				foreach($this->cmdmap[$table] as $id => $incomingCmdArray)	{
+				foreach ($this->cmdmap[$table] as $id => $incomingCmdArray) {
-					if (is_array($incomingCmdArray))	{	// have found a command.
+					if (is_array($incomingCmdArray)) { // have found a command.
 
 							// Get command and value (notice, only one command is observed at a time!):
 						reset($incomingCmdArray);
@@ -2630,22 +2624,22 @@
 							}
 						}
 
-						// only execute default commands if a hook hasn't been processed the command already
+							// only execute default commands if a hook hasn't been processed the command already
 						if (!$commandIsProcessed) {
 								// Branch, based on command
 							switch ($command) {
 								case 'move':
-									$this->moveRecord($table,$id,$value);
+									$this->moveRecord($table, $id, $value);
 								break;
 								case 'copy':
-									if ($table === 'pages')	{
+									if ($table === 'pages') {
-										$this->copyPages($id,$value);
+										$this->copyPages($id, $value);
 									} else {
-										$this->copyRecord($table,$id,$value,1);
+										$this->copyRecord($table, $id, $value, 1);
 									}
 								break;
 								case 'localize':
-									$this->localize($table,$id,$value);
+									$this->localize($table, $id, $value);
 								break;
 								case 'inlineLocalizeSynchronize':
 									$this->inlineLocalizeSynchronize($table, $id, $value);
@@ -2686,15 +2680,6 @@
 	}
 
 
-
-
-
-
-
-
-
-
-
 	/*********************************************
 	 *
 	 * Cmd: Copying
@@ -2713,38 +2698,38 @@
 	 * @param	integer		Language ID (from sys_language table)
 	 * @return	integer		ID of new record, if any
 	 */
-	function copyRecord($table, $uid, $destPid, $first=0, $overrideValues=array(), $excludeFields='', $language=0) {
+	function copyRecord($table, $uid, $destPid, $first = 0, $overrideValues = array(), $excludeFields = '', $language = 0) {
 		global $TCA;
 
 		$uid = $origUid = intval($uid);
 			// Only copy if the table is defined in TCA, a uid is given and the record wasn't copied before:
-		if ($TCA[$table] && $uid && !$this->isRecordCopied($table, $uid))	{
+		if ($TCA[$table] && $uid && !$this->isRecordCopied($table, $uid)) {
 			t3lib_div::loadTCA($table);
-/*
-				// In case the record to be moved turns out to be an offline version, we have to find the live version and work on that one (this case happens for pages with "branch" versioning type)
-			if ($lookForLiveVersion = t3lib_BEfunc::getLiveVersionOfRecord($table,$uid,'uid'))	{
-				$uid = $lookForLiveVersion['uid'];
-			}
-				// Get workspace version of the source record, if any: Then we will copy workspace version instead:
-			if ($WSversion = t3lib_BEfunc::getWorkspaceVersionOfRecord($this->BE_USER->workspace, $table, $uid, 'uid,t3ver_oid'))	{
-				$uid = $WSversion['uid'];
-			}
-				// Now, the $uid is the actual record we will copy while $origUid is the record we asked to get copied - but that could be a live version.
-*/
+			/*
+				   // In case the record to be moved turns out to be an offline version, we have to find the live version and work on that one (this case happens for pages with "branch" versioning type)
+			   if ($lookForLiveVersion = t3lib_BEfunc::getLiveVersionOfRecord($table,$uid,'uid'))	{
+				   $uid = $lookForLiveVersion['uid'];
+			   }
+				   // Get workspace version of the source record, if any: Then we will copy workspace version instead:
+			   if ($WSversion = t3lib_BEfunc::getWorkspaceVersionOfRecord($this->BE_USER->workspace, $table, $uid, 'uid,t3ver_oid'))	{
+				   $uid = $WSversion['uid'];
+			   }
+				   // Now, the $uid is the actual record we will copy while $origUid is the record we asked to get copied - but that could be a live version.
+   */
-			if ($this->doesRecordExist($table,$uid,'show'))	{		// This checks if the record can be selected which is all that a copy action requires.
+			if ($this->doesRecordExist($table, $uid, 'show')) { // This checks if the record can be selected which is all that a copy action requires.
 				$fullLanguageCheckNeeded = ($table != 'pages');
-				if (($language > 0 && $this->BE_USER->checkLanguageAccess($language) ) ||
+				if (($language > 0 && $this->BE_USER->checkLanguageAccess($language)) ||
-						$this->BE_USER->recordEditAccessInternals(
+					$this->BE_USER->recordEditAccessInternals(
-							$table, $uid, false, false, $fullLanguageCheckNeeded
+						$table, $uid, FALSE, FALSE, $fullLanguageCheckNeeded
-						)
-					) { //Used to check language and general editing rights
+					)
+				) { //Used to check language and general editing rights
-					$data = Array();
+					$data = array();
 
-					$nonFields = array_unique(t3lib_div::trimExplode(',','uid,perms_userid,perms_groupid,perms_user,perms_group,perms_everybody,t3ver_oid,t3ver_wsid,t3ver_id,t3ver_label,t3ver_state,t3ver_swapmode,t3ver_count,t3ver_stage,t3ver_tstamp,'.$excludeFields,1));
+					$nonFields = array_unique(t3lib_div::trimExplode(',', 'uid,perms_userid,perms_groupid,perms_user,perms_group,perms_everybody,t3ver_oid,t3ver_wsid,t3ver_id,t3ver_label,t3ver_state,t3ver_swapmode,t3ver_count,t3ver_stage,t3ver_tstamp,' . $excludeFields, 1));
 
-					// $row = $this->recordInfo($table,$uid,'*');
+						// $row = $this->recordInfo($table,$uid,'*');
-					$row = t3lib_BEfunc::getRecordWSOL($table,$uid);	// So it copies (and localized) content from workspace...
+					$row = t3lib_BEfunc::getRecordWSOL($table, $uid); // So it copies (and localized) content from workspace...
-					if (is_array($row))	{
+					if (is_array($row)) {
 
 							// Initializing:
 						$theNewID = uniqid('NEW');
@@ -2755,28 +2740,28 @@
 						$defaultData = $this->newFieldArray($table);
 
 							// Getting "copy-after" fields if applicable:
-						$copyAfterFields = $destPid<0 ? $this->fixCopyAfterDuplFields($table,$uid,abs($destPid),0) : array();
+						$copyAfterFields = $destPid < 0 ? $this->fixCopyAfterDuplFields($table, $uid, abs($destPid), 0) : array();
 
 							// Page TSconfig related:
-						$tscPID = t3lib_BEfunc::getTSconfig_pidValue($table,$uid,$destPid);	// NOT using t3lib_BEfunc::getTSCpid() because we need the real pid - not the ID of a page, if the input is a page...
+						$tscPID = t3lib_BEfunc::getTSconfig_pidValue($table, $uid, $destPid); // NOT using t3lib_BEfunc::getTSCpid() because we need the real pid - not the ID of a page, if the input is a page...
 						$TSConfig = $this->getTCEMAIN_TSconfig($tscPID);
-						$tE = $this->getTableEntries($table,$TSConfig);
+						$tE = $this->getTableEntries($table, $TSConfig);
 
 							// Traverse ALL fields of the selected record:
-						foreach($row as $field => $value)	{
+						foreach ($row as $field => $value) {
-							if (!in_array($field,$nonFields))	{
+							if (!in_array($field, $nonFields)) {
 
 									// Get TCA configuration for the field:
 								$conf = $TCA[$table]['columns'][$field]['config'];
 
 									// Preparation/Processing of the value:
-								if ($field=='pid')	{	// "pid" is hardcoded of course:
+								if ($field == 'pid') { // "pid" is hardcoded of course:
 									$value = $destPid;
-								} elseif (isset($overrideValues[$field]))	{	// Override value...
+								} elseif (isset($overrideValues[$field])) { // Override value...
 									$value = $overrideValues[$field];
-								} elseif (isset($copyAfterFields[$field]))	{	// Copy-after value if available:
+								} elseif (isset($copyAfterFields[$field])) { // Copy-after value if available:
 									$value = $copyAfterFields[$field];
-								} elseif ($TCA[$table]['ctrl']['setToDefaultOnCopy'] && t3lib_div::inList($TCA[$table]['ctrl']['setToDefaultOnCopy'],$field))	{	// Revert to default for some fields:
+								} elseif ($TCA[$table]['ctrl']['setToDefaultOnCopy'] && t3lib_div::inList($TCA[$table]['ctrl']['setToDefaultOnCopy'], $field)) { // Revert to default for some fields:
 									$value = $defaultData[$field];
 								} else {
 										// Hide at copy may override:
@@ -2785,7 +2770,7 @@
 									}
 										// Prepend label on copy:
 									if ($first && $field == $headerField && $TCA[$table]['ctrl']['prependAtCopy'] && !$tE['disablePrependAtCopy']) {
-										$value = $this->getCopyHeader($table,$this->resolvePid($table,$destPid),$field,$this->clearPrefixFromValue($table,$value),0);
+										$value = $this->getCopyHeader($table, $this->resolvePid($table, $destPid), $field, $this->clearPrefixFromValue($table, $value), 0);
 									}
 										// Processing based on the TCA config field type (files, references, flexforms...)
 									$value = $this->copyRecord_procBasedOnFieldType($table, $uid, $field, $value, $row, $conf, $tscPID, $language);
@@ -2810,10 +2795,10 @@
 						/* @var $copyTCE t3lib_TCEmain  */
 						$copyTCE->stripslashes_values = 0;
 						$copyTCE->copyTree = $this->copyTree;
-						$copyTCE->cachedTSconfig = $this->cachedTSconfig;	// Copy forth the cached TSconfig
+						$copyTCE->cachedTSconfig = $this->cachedTSconfig; // Copy forth the cached TSconfig
-						$copyTCE->dontProcessTransformations=1;		// Transformations should NOT be carried out during copy
+						$copyTCE->dontProcessTransformations = 1; // Transformations should NOT be carried out during copy
 
-						$copyTCE->start($data,'',$this->BE_USER);
+						$copyTCE->start($data, '', $this->BE_USER);
 						$copyTCE->process_datamap();
 
 							// Getting the new UID:
@@ -2832,18 +2817,24 @@
 						$this->errorLog = array_merge($this->errorLog, $copyTCE->errorLog);
 						unset($copyTCE);
 
-						if($language == 0) {
+						if ($language == 0) {
 								//repointing the new translation records to the parent record we just created
 							$overrideValues[$GLOBALS['TCA'][$table]['ctrl']['transOrigPointerField']] = $theNewSQLID;
-							$this->copyL10nOverlayRecords($table, $uid, $destPid<0 ? $tscPID : $destPid , $first, $overrideValues, $excludeFields);
+							$this->copyL10nOverlayRecords($table, $uid, $destPid < 0 ? $tscPID : $destPid, $first, $overrideValues, $excludeFields);
 						}
 
 						return $theNewSQLID;
-					} else $this->log($table,$uid,3,0,1,'Attempt to copy record that did not exist!');
-				}  else $this->log($table,$uid,3,0,1,'Attempt to copy record without having permissions to do so. ['.$this->BE_USER->errorMsg.'].');
-			} else $this->log($table,$uid,3,0,1,'Attempt to copy record without permission');
+					} else {
+						$this->log($table, $uid, 3, 0, 1, 'Attempt to copy record that did not exist!');
-		}
+					}
+				} else {
+					$this->log($table, $uid, 3, 0, 1, 'Attempt to copy record without having permissions to do so. [' . $this->BE_USER->errorMsg . '].');
-	}
+				}
+			} else {
+				$this->log($table, $uid, 3, 0, 1, 'Attempt to copy record without permission');
+			}
+		}
+	}
 
 	/**
 	 * Copying pages
@@ -2853,17 +2844,17 @@
 	 * @param	integer		Destination PID: >=0 then it points to a page-id on which to insert the record (as the first element). <0 then it points to a uid from its own table after which to insert it (works if
 	 * @return	void
 	 */
-	function copyPages($uid,$destPid)	{
+	function copyPages($uid, $destPid) {
 
 			// Initialize:
 		$uid = intval($uid);
 		$destPid = intval($destPid);
 
 			// Finding list of tables to copy.
-		$copyTablesArray = $this->admin ? $this->compileAdminTables() : explode(',',$this->BE_USER->groupData['tables_modify']);	// These are the tables, the user may modify
+		$copyTablesArray = $this->admin ? $this->compileAdminTables() : explode(',', $this->BE_USER->groupData['tables_modify']); // These are the tables, the user may modify
-		if (!strstr($this->copyWhichTables,'*'))	{		// If not all tables are allowed then make a list of allowed tables: That is the tables that figure in both allowed tables AND the copyTable-list
+		if (!strstr($this->copyWhichTables, '*')) { // If not all tables are allowed then make a list of allowed tables: That is the tables that figure in both allowed tables AND the copyTable-list
-			foreach($copyTablesArray as $k => $table)	{
+			foreach ($copyTablesArray as $k => $table) {
-				if (!$table || !t3lib_div::inList($this->copyWhichTables.',pages',$table))	{	// pages are always going...
+				if (!$table || !t3lib_div::inList($this->copyWhichTables . ',pages', $table)) { // pages are always going...
 					unset($copyTablesArray[$k]);
 				}
 			}
@@ -2871,30 +2862,30 @@
 		$copyTablesArray = array_unique($copyTablesArray);
 
 			// Begin to copy pages if we're allowed to:
-		if ($this->admin || in_array('pages',$copyTablesArray))	{
+		if ($this->admin || in_array('pages', $copyTablesArray)) {
 
 				// Copy this page we're on. And set first-flag (this will trigger that the record is hidden if that is configured)!
-			$theNewRootID = $this->copySpecificPage($uid,$destPid,$copyTablesArray,1);
+			$theNewRootID = $this->copySpecificPage($uid, $destPid, $copyTablesArray, 1);
 
 				// If we're going to copy recursively...:
-			if ($theNewRootID && $this->copyTree)	{
+			if ($theNewRootID && $this->copyTree) {
 
 					// Get ALL subpages to copy (read-permissions are respected!):
-				$CPtable = $this->int_pageTreeInfo(Array(), $uid, intval($this->copyTree), $theNewRootID);
+				$CPtable = $this->int_pageTreeInfo(array(), $uid, intval($this->copyTree), $theNewRootID);
 
 					// Now copying the subpages:
-				foreach($CPtable as $thePageUid => $thePagePid)	{
+				foreach ($CPtable as $thePageUid => $thePagePid) {
 					$newPid = $this->copyMappingArray['pages'][$thePagePid];
-					if (isset($newPid))	{
+					if (isset($newPid)) {
-						$this->copySpecificPage($thePageUid,$newPid,$copyTablesArray);
+						$this->copySpecificPage($thePageUid, $newPid, $copyTablesArray);
 					} else {
-						$this->log('pages',$uid,5,0,1,'Something went wrong during copying branch');
+						$this->log('pages', $uid, 5, 0, 1, 'Something went wrong during copying branch');
 						break;
 					}
 				}
-			}	// else the page was not copied. Too bad...
+			} // else the page was not copied. Too bad...
 		} else {
-			$this->log('pages',$uid,5,0,1,'Attempt to copy page without permission to this table');
+			$this->log('pages', $uid, 5, 0, 1, 'Attempt to copy page without permission to this table');
 		}
 	}
 
@@ -2907,19 +2898,19 @@
 	 * @param	boolean		$first is a flag set, if the record copied is NOT a 'slave' to another record copied. That is, if this record was asked to be copied in the cmd-array
 	 * @return	integer		The id of the new page, if applicable.
 	 */
-	function copySpecificPage($uid,$destPid,$copyTablesArray,$first=0)	{
+	function copySpecificPage($uid, $destPid, $copyTablesArray, $first = 0) {
 		global $TCA;
 
 			// Copy the page itself:
-		$theNewRootID = $this->copyRecord('pages',$uid,$destPid,$first);
+		$theNewRootID = $this->copyRecord('pages', $uid, $destPid, $first);
 
 			// If a new page was created upon the copy operation we will proceed with all the tables ON that page:
-		if ($theNewRootID)	{
+		if ($theNewRootID) {
-			foreach($copyTablesArray as $table)	{
+			foreach ($copyTablesArray as $table) {
-				if ($table && is_array($TCA[$table]) && $table!='pages')	{	// all records under the page is copied.
+				if ($table && is_array($TCA[$table]) && $table != 'pages') { // all records under the page is copied.
-					$mres = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid', $table, 'pid='.intval($uid).$this->deleteClause($table), '', ($TCA[$table]['ctrl']['sortby'] ? $TCA[$table]['ctrl']['sortby'].' DESC' : ''));
+					$mres = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid', $table, 'pid=' . intval($uid) . $this->deleteClause($table), '', ($TCA[$table]['ctrl']['sortby'] ? $TCA[$table]['ctrl']['sortby'] . ' DESC' : ''));
-					while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($mres))	{
+					while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($mres)) {
-						$this->copyRecord($table,$row['uid'], $theNewRootID);	// Copying each of the underlying records...
+						$this->copyRecord($table, $row['uid'], $theNewRootID); // Copying each of the underlying records...
 					}
 					$GLOBALS['TYPO3_DB']->sql_free_result($mres);
 				}
@@ -2942,34 +2933,34 @@
 	 * @param	array		Override array - must NOT contain any fields not in the table!
 	 * @return	integer		Returns the new ID of the record (if applicable)
 	 */
-	function copyRecord_raw($table,$uid,$pid,$overrideArray=array())	{
+	function copyRecord_raw($table, $uid, $pid, $overrideArray = array()) {
 		global $TCA;
 
 		$uid = intval($uid);
 			// Only copy if the table is defined in TCA, a uid is given and the record wasn't copied before:
-		if ($TCA[$table] && $uid && !$this->isRecordCopied($table, $uid))	{
+		if ($TCA[$table] && $uid && !$this->isRecordCopied($table, $uid)) {
 			t3lib_div::loadTCA($table);
-			if ($this->doesRecordExist($table,$uid,'show'))	{
+			if ($this->doesRecordExist($table, $uid, 'show')) {
 
 					// Set up fields which should not be processed. They are still written - just passed through no-questions-asked!
-				$nonFields = array('uid','pid','t3ver_id','t3ver_oid','t3ver_wsid','t3ver_label','t3ver_state','t3ver_swapmode','t3ver_count','t3ver_stage','t3ver_tstamp','perms_userid','perms_groupid','perms_user','perms_group','perms_everybody');
+				$nonFields = array('uid', 'pid', 't3ver_id', 't3ver_oid', 't3ver_wsid', 't3ver_label', 't3ver_state', 't3ver_swapmode', 't3ver_count', 't3ver_stage', 't3ver_tstamp', 'perms_userid', 'perms_groupid', 'perms_user', 'perms_group', 'perms_everybody');
 
 					// Select main record:
-				$row = $this->recordInfo($table,$uid,'*');
+				$row = $this->recordInfo($table, $uid, '*');
-				if (is_array($row))	{
+				if (is_array($row)) {
 
 						// Merge in override array.
-					$row = array_merge($row,$overrideArray);
+					$row = array_merge($row, $overrideArray);
 
 						// Traverse ALL fields of the selected record:
-					foreach($row as $field => $value)	{
+					foreach ($row as $field => $value) {
-						if (!in_array($field,$nonFields))	{
+						if (!in_array($field, $nonFields)) {
 
 								// Get TCA configuration for the field:
 							$conf = $TCA[$table]['columns'][$field]['config'];
-							if (is_array($conf))	{
+							if (is_array($conf)) {
 									// Processing based on the TCA config field type (files, references, flexforms...)
-								$value = $this->copyRecord_procBasedOnFieldType($table,$uid,$field,$value,$row,$conf,$pid);
+								$value = $this->copyRecord_procBasedOnFieldType($table, $uid, $field, $value, $row, $conf, $pid);
 							}
 
 								// Add value to array.
@@ -2981,22 +2972,26 @@
 					$row['pid'] = $pid;
 
 						// Setting original UID:
-					if ($TCA[$table]['ctrl']['origUid'])	{
+					if ($TCA[$table]['ctrl']['origUid']) {
 						$row[$TCA[$table]['ctrl']['origUid']] = $uid;
 					}
 
 						// Do the copy by internal function
-					$theNewSQLID = $this->insertNewCopyVersion($table,$row,$pid);
+					$theNewSQLID = $this->insertNewCopyVersion($table, $row, $pid);
-					if ($theNewSQLID)	{
+					if ($theNewSQLID) {
 						$this->dbAnalysisStoreExec();
 						$this->dbAnalysisStore = array();
-						$this->copyRecord_fixRTEmagicImages($table,t3lib_BEfunc::wsMapId($table,$theNewSQLID));
+						$this->copyRecord_fixRTEmagicImages($table, t3lib_BEfunc::wsMapId($table, $theNewSQLID));
 						return $this->copyMappingArray[$table][$uid] = $theNewSQLID;
 					}
-				} else $this->log($table,$uid,3,0,1,'Attempt to rawcopy/versionize record that did not exist!');
-			} else $this->log($table,$uid,3,0,1,'Attempt to rawcopy/versionize record without copy permission');
+				} else {
+					$this->log($table, $uid, 3, 0, 1, 'Attempt to rawcopy/versionize record that did not exist!');
-		}
+				}
+			} else {
+				$this->log($table, $uid, 3, 0, 1, 'Attempt to rawcopy/versionize record without copy permission');
-	}
+			}
+		}
+	}
 
 	/**
 	 * Inserts a record in the database, passing TCA configuration values through checkValue() but otherwise does NOTHING and checks nothing regarding permissions.
@@ -3007,7 +3002,7 @@
 	 * @param	integer		The value of PID field.  -1 is indication that we are creating a new version!
 	 * @return	integer		Returns the new ID of the record (if applicable)
 	 */
-	function insertNewCopyVersion($table,$fieldArray,$realPid)	{
+	function insertNewCopyVersion($table, $fieldArray, $realPid) {
 		global $TCA;
 
 		$id = uniqid('NEW');
@@ -3021,29 +3016,29 @@
 		$this->dontProcessTransformations = TRUE;
 
 			// Traverse record and input-process each value:
-		foreach($fieldArray as $field => $fieldValue)	{
+		foreach ($fieldArray as $field => $fieldValue) {
-			if (isset($TCA[$table]['columns'][$field]))	{
+			if (isset($TCA[$table]['columns'][$field])) {
-				// Evaluating the value.
+					// Evaluating the value.
-				$res = $this->checkValue($table,$field,$fieldValue,$id,'new',$realPid,0);
+				$res = $this->checkValue($table, $field, $fieldValue, $id, 'new', $realPid, 0);
-				if (isset($res['value']))	{
+				if (isset($res['value'])) {
 					$fieldArray[$field] = $res['value'];
 				}
 			}
 		}
 
 			// System fields being set:
-		if ($TCA[$table]['ctrl']['crdate'])	{
+		if ($TCA[$table]['ctrl']['crdate']) {
 			$fieldArray[$TCA[$table]['ctrl']['crdate']] = $GLOBALS['EXEC_TIME'];
 		}
-		if ($TCA[$table]['ctrl']['cruser_id'])	{
+		if ($TCA[$table]['ctrl']['cruser_id']) {
-			$fieldArray[$TCA[$table]['ctrl']['cruser_id']]=$this->userid;
+			$fieldArray[$TCA[$table]['ctrl']['cruser_id']] = $this->userid;
 		}
-		if ($TCA[$table]['ctrl']['tstamp'])	{
+		if ($TCA[$table]['ctrl']['tstamp']) {
 			$fieldArray[$TCA[$table]['ctrl']['tstamp']] = $GLOBALS['EXEC_TIME'];
 		}
 
 			// Finally, insert record:
-		$this->insertDB($table,$id,$fieldArray, TRUE);
+		$this->insertDB($table, $id, $fieldArray, TRUE);
 			// Process the remap stack in case we dealed with relations:
 		$this->processRemapStack();
 
@@ -3069,7 +3064,7 @@
 	 * @access private
 	 * @see copyRecord()
 	 */
-	function copyRecord_procBasedOnFieldType($table, $uid, $field, $value, $row, $conf, $realDestPid, $language=0) {
+	function copyRecord_procBasedOnFieldType($table, $uid, $field, $value, $row, $conf, $realDestPid, $language = 0) {
 		global $TCA;
 
 			// Process references and files, currently that means only the files, prepending absolute paths (so the TCEmain engine will detect the file as new and one that should be made into a copy)
@@ -3077,11 +3072,11 @@
 		$inlineSubType = $this->getInlineFieldType($conf);
 
 			// Register if there are references to take care of or MM is used on an inline field (no change to value):
-		if ($this->isReferenceField($conf) || $inlineSubType == 'mm')	{
+		if ($this->isReferenceField($conf) || $inlineSubType == 'mm') {
-			$allowedTables = $conf['type']=='group' ? $conf['allowed'] : $conf['foreign_table'].','.$conf['neg_foreign_table'];
+			$allowedTables = $conf['type'] == 'group' ? $conf['allowed'] : $conf['foreign_table'] . ',' . $conf['neg_foreign_table'];
-			$prependName = $conf['type']=='group' ? $conf['prepend_tname'] : $conf['neg_foreign_table'];
+			$prependName = $conf['type'] == 'group' ? $conf['prepend_tname'] : $conf['neg_foreign_table'];
 			$localizeReferences = (isset($conf['foreign_table']) && t3lib_BEfunc::isTableLocalizable($conf['foreign_table']) && isset($conf['localizeReferencesAtParentLocalization']) && $conf['localizeReferencesAtParentLocalization']);
-			if ($conf['MM'] || $language>0 && $localizeReferences) {
+			if ($conf['MM'] || $language > 0 && $localizeReferences) {
 				$dbAnalysis = t3lib_div::makeInstance('t3lib_loadDBGroup');
 				/* @var $dbAnalysis t3lib_loadDBGroup */
 				$dbAnalysis->start($value, $allowedTables, $conf['MM'], $uid, $table, $conf);
@@ -3097,19 +3092,19 @@
 						}
 					}
 				}
-				$value = implode(',',$dbAnalysis->getValueArray($prependName));
+				$value = implode(',', $dbAnalysis->getValueArray($prependName));
 			}
-			if ($value)	{	// Setting the value in this array will notify the remapListedDBRecords() function that this field MAY need references to be corrected
+			if ($value) { // Setting the value in this array will notify the remapListedDBRecords() function that this field MAY need references to be corrected
 				$this->registerDBList[$table][$uid][$field] = $value;
 			}
 
 			// If another inline subtype is used (comma-separated-values or the foreign_field property):
-		} elseif ($inlineSubType !== false) {
+		} elseif ($inlineSubType !== FALSE) {
 				// Get the localization mode for the current (parent) record (keep|select|all):
 			$localizationMode = t3lib_BEfunc::getInlineLocalizationMode($table, $field);
 				// Localization in mode 'keep', isn't a real localization, but keeps the children of the original parent record:
-			if ($language>0 && $localizationMode=='keep') {
+			if ($language > 0 && $localizationMode == 'keep') {
-				$value = ($inlineSubType=='field' ? 0 : '');
+				$value = ($inlineSubType == 'field' ? 0 : '');
 				// Execute copy or localization actions:
 			} else {
 				/*
@@ -3124,10 +3119,10 @@
 						// If language is set and differs from original record, this isn't a copy action but a localization of our parent/ancestor:
 					if ($language > 0 && t3lib_BEfunc::isTableLocalizable($table) && $language != $row[$TCA[$table]['ctrl']['languageField']]) {
 							// If children should be localized when the parent gets localized the first time, just do it:
-						if ($localizationMode!=false && isset($conf['behaviour']['localizeChildrenAtParentLocalization']) && $conf['behaviour']['localizeChildrenAtParentLocalization']) {
+						if ($localizationMode != FALSE && isset($conf['behaviour']['localizeChildrenAtParentLocalization']) && $conf['behaviour']['localizeChildrenAtParentLocalization']) {
 							$newId = $this->localize($v['table'], $v['id'], $language);
 						}
-						// If no language it set, this is a regular copy action:
+							// If no language it set, this is a regular copy action:
 					} else {
 						if (!t3lib_div::testInt($realDestPid)) {
 							$newId = $this->copyRecord($v['table'], $v['id'], -$v['id']);
@@ -3159,29 +3154,29 @@
 				}
 
 					// Store the new values, we will set up the uids for the subtype later on (exception keep localization from original record):
-				$value = implode(',',$dbAnalysis->getValueArray());
+				$value = implode(',', $dbAnalysis->getValueArray());
 				$this->registerDBList[$table][$uid][$field] = $value;
 			}
 		}
 
 			// For "flex" fieldtypes we need to traverse the structure for two reasons: If there are file references they have to be prepended with absolute paths and if there are database reference they MIGHT need to be remapped (still done in remapListedDBRecords())
-		if ($conf['type']=='flex')	{
+		if ($conf['type'] == 'flex') {
 
 				// Get current value array:
 			$dataStructArray = t3lib_BEfunc::getFlexFormDS($conf, $row, $table);
 			$currentValueArray = t3lib_div::xml2array($value);
 
 				// Traversing the XML structure, processing files:
-			if (is_array($currentValueArray))	{
+			if (is_array($currentValueArray)) {
 				$currentValueArray['data'] = $this->checkValue_flex_procInData(
-							$currentValueArray['data'],
+					$currentValueArray['data'],
-							array(),	// Not used.
+					array(), // Not used.
-							array(),	// Not used.
+					array(), // Not used.
-							$dataStructArray,
+					$dataStructArray,
-							array($table, $uid, $field, $realDestPid),	// Parameters.
+					array($table, $uid, $field, $realDestPid), // Parameters.
-							'copyRecord_flexFormCallBack'
-						);
+					'copyRecord_flexFormCallBack'
+				);
-				$value = $currentValueArray;	// Setting value as an array! -> which means the input will be processed according to the 'flex' type when the new copy is created.
+				$value = $currentValueArray; // Setting value as an array! -> which means the input will be processed according to the 'flex' type when the new copy is created.
 			}
 		}
 
@@ -3199,7 +3194,7 @@
 	 * @return	array		Result array with key "value" containing the value of the processing.
 	 * @see copyRecord(), checkValue_flex_procInData_travDS()
 	 */
-	function copyRecord_flexFormCallBack($pParams, $dsConf, $dataValue, $dataValue_ext1, $dataValue_ext2)	{
+	function copyRecord_flexFormCallBack($pParams, $dsConf, $dataValue, $dataValue_ext1, $dataValue_ext2) {
 
 			// Extract parameters:
 		list($table, $uid, $field, $realDestPid) = $pParams;
@@ -3228,26 +3223,26 @@
 	 * @return	string		The (possibly modified) value
 	 * @see copyRecord(), copyRecord_flexFormCallBack()
 	 */
-	function copyRecord_procFilesRefs($conf, $uid, $value)	{
+	function copyRecord_procFilesRefs($conf, $uid, $value) {
 
 			// Prepend absolute paths to files:
 		if ($conf['type'] == 'group' && ($conf['internal_type'] == 'file' || $conf['internal_type'] == 'file_reference')) {
 
 				// Get an array with files as values:
-			if ($conf['MM'])	{
+			if ($conf['MM']) {
 				$theFileValues = array();
 
 				$dbAnalysis = t3lib_div::makeInstance('t3lib_loadDBGroup');
 				/* @var $dbAnalysis t3lib_loadDBGroup */
 				$dbAnalysis->start('', 'files', $conf['MM'], $uid);
 
-				foreach($dbAnalysis->itemArray as $somekey => $someval)	{
+				foreach ($dbAnalysis->itemArray as $somekey => $someval) {
-					if ($someval['id'])	{
+					if ($someval['id']) {
 						$theFileValues[] = $someval['id'];
 					}
 				}
 			} else {
-				$theFileValues = t3lib_div::trimExplode(',',$value,1);
+				$theFileValues = t3lib_div::trimExplode(',', $value, 1);
 			}
 
 				// Traverse this array of files:
@@ -3255,17 +3250,17 @@
 			$dest = $this->destPathFromUploadFolder($uploadFolder);
 			$newValue = array();
 
-			foreach($theFileValues as $file)	{
+			foreach ($theFileValues as $file) {
-				if (trim($file))	{
+				if (trim($file)) {
 					$realFile = str_replace('//', '/', $dest . '/' . trim($file));
-					if (@is_file($realFile))	{
+					if (@is_file($realFile)) {
 						$newValue[] = $realFile;
 					}
 				}
 			}
 
 				// Implode the new filelist into the new value (all files have absolute paths now which means they will get copied when entering TCEmain as new values...)
-			$value = implode(',',$newValue);
+			$value = implode(',', $newValue);
 		}
 
 			// Return the new value:
@@ -3281,13 +3276,13 @@
 	 * @param	integer		Record UID
 	 * @return	void
 	 */
-	function copyRecord_fixRTEmagicImages($table,$theNewSQLID)	{
+	function copyRecord_fixRTEmagicImages($table, $theNewSQLID) {
 		global $TYPO3_DB;
 
 			// Creating fileFunc object.
-		if (!$this->fileFunc)	{
+		if (!$this->fileFunc) {
 			$this->fileFunc = t3lib_div::makeInstance('t3lib_basicFileFunctions');
-			$this->include_filefunctions=1;
+			$this->include_filefunctions = 1;
 		}
 
 			// Select all RTEmagic files in the reference table from the table/ID
